#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#define XK_MISCELLANY
#define XK_LATIN1
#define XK_LATIN2
#define XK_LATIN3
#define XK_LATIN4
#define XK_CYRILLIC
#define XK_GREEK
#define XK_XKB_KEYS
#include <X11/keysymdef.h>
#include <X11/Xutil.h>

#if 0
	#define FRENCH_VERBOSE
#endif


struct DEAD_STATUS{
	char grave;
	char conf;
	char trema;
	char french_active;
};

static KeySym french_kbd (
	struct DEAD_STATUS *dead,
	KeySym keysym,
	int is_shift)
{
	KeySym newkey = NoSymbol;
	if (keysym == XK_slash){
		if (dead->grave){
			newkey = keysym;
			dead->grave = 0;
		}else{
			newkey = XK_eacute;
		}
	}else if (keysym == XK_question){
		if (dead->grave){
			newkey = keysym;
			dead->grave = 0;
		}else{
			newkey = XK_Eacute;
		}
	}else{
		KeySym newkey_grave = 0;
		KeySym newkey_conf  = 0;
		KeySym newkey_trema = 0;
		if (keysym == XK_apostrophe){
			if (is_shift){
				if (!dead->conf){
					dead->conf = 1;
					return NoSymbol;
				}else{
					dead->conf = 0;
					newkey = keysym;
				}
			}else{
				if (!dead->grave){
					dead->grave = 1;
					return NoSymbol;
				}else{
					dead->grave = 0;
					newkey = keysym;
				}
			}
		}else if (keysym == XK_quotedbl){
			if (!dead->conf){
				dead->conf = 1;
				return NoSymbol;
			}else{
				dead->conf = 0;
				newkey = keysym;
			}
		}else if (keysym == XK_grave){
			if (is_shift){
				if (!dead->trema){
					dead->trema = 1;
					return NoSymbol;
				}else{
					dead->trema = 0;
					newkey = keysym;
				}
			}else{
				newkey = keysym;
			}
		}else if (keysym == XK_asciitilde){
			if (!dead->trema){
				dead->trema = 1;
				return NoSymbol;
			}else{
				dead->trema = 0;
				newkey = keysym;
			}
		}else if (keysym == XK_a){
			newkey_grave = XK_agrave;
			newkey_conf  = XK_acircumflex;
			newkey_trema = XK_adiaeresis;
		}else if (keysym == XK_e){
			newkey_grave = XK_egrave;
			newkey_conf  = XK_ecircumflex;
			newkey_trema = XK_ediaeresis;
		}else if (keysym == XK_i){
			newkey_grave = XK_igrave;
			newkey_conf  = XK_icircumflex;
			newkey_trema = XK_idiaeresis;
		}else if (keysym == XK_o){
			newkey_grave = XK_ograve;
			newkey_conf  = XK_ocircumflex;
			newkey_trema = XK_odiaeresis;
		}else if (keysym == XK_u){
			newkey_grave = XK_ugrave;
			newkey_conf  = XK_ucircumflex;
			newkey_trema = XK_udiaeresis;
		}else if (keysym == XK_c){
			newkey_grave = XK_ccedilla;

		}else if (keysym == XK_A){
			newkey_grave = XK_Agrave;
			newkey_conf  = XK_Acircumflex;
			newkey_trema = XK_Adiaeresis;
		}else if (keysym == XK_E){
			newkey_grave = XK_Egrave;
			newkey_conf  = XK_Ecircumflex;
			newkey_trema = XK_Ediaeresis;
		}else if (keysym == XK_I){
			newkey_grave = XK_Igrave;
			newkey_conf  = XK_Icircumflex;
			newkey_trema = XK_Idiaeresis;
		}else if (keysym == XK_O){
			newkey_grave = XK_Ograve;
			newkey_conf  = XK_Ocircumflex;
			newkey_trema = XK_Odiaeresis;
		}else if (keysym == XK_U){
			newkey_grave = XK_Ugrave;
			newkey_conf  = XK_Ucircumflex;
			newkey_trema = XK_Udiaeresis;
		}else if (keysym == XK_C){
			newkey_grave = XK_Ccedilla;


		}else{
			return NoSymbol;
		}
		if (dead->grave){
			newkey = newkey_grave;
			dead->grave = 0;
		}else if (dead->conf){
			newkey = newkey_conf;
			dead->conf = 0;
		}else if (dead->trema){
			newkey = newkey_trema;
			dead->trema = 0;
		}else{
			newkey = keysym;
		}
	}
	return newkey;
}

static KeySym french_kbdif (
	Display *dpy,
	KeySym keysym,
	int is_shift,
	struct DEAD_STATUS *status)
{
	char resetdead = 0;
	if (keysym == XK_Pause
		|| keysym == XK_Sys_Req){
		status->french_active = !status->french_active;
		resetdead = 1;
		XBell (dpy,50);
		keysym = NoSymbol;
	}else if (status->french_active){	
		#ifdef FRENCH_VERBOSE
			KeySym old = keysym;
		#endif
		if (keysym == XK_apostrophe
			|| keysym == XK_a
			|| keysym == XK_e
			|| keysym == XK_i
			|| keysym == XK_o
			|| keysym == XK_u
			|| keysym == XK_c

			|| keysym == XK_quotedbl
			|| keysym == XK_A
			|| keysym == XK_E
			|| keysym == XK_I
			|| keysym == XK_O
			|| keysym == XK_U
			|| keysym == XK_C

			|| keysym == XK_grave
			|| keysym == XK_asciitilde
			|| keysym == XK_slash
			|| keysym == XK_question){
			keysym = french_kbd(status,keysym,is_shift);
		}else if (keysym != XK_Shift_L
			&& keysym != XK_Shift_R
			&& keysym != XK_Control_L
			&& keysym != XK_Control_R
			&& keysym != XK_Caps_Lock
			&& keysym != XK_Shift_Lock
			&& keysym != XK_Meta_L
			&& keysym != XK_Meta_R
			&& keysym != XK_Alt_L
			&& keysym != XK_Alt_R
			&& keysym != 0){
			resetdead = 1;
		}
		#ifdef FRENCH_VERBOSE
			printf ("kbdif %x -> %x\n",(int)old,(int)keysym);
			fflush (stdout);
		#endif
	}else{
		resetdead = 1;
	}
	if (resetdead){
		status->conf = status->grave = status->trema = 0;
	}
	return keysym;
}

KeySym X11_kbdfilter(
	XKeyEvent *event,
	KeySym keysym,
	XComposeStatus *status)
{
	KeySym ret = keysym;
	if (event->type == KeyPress){
		/* We can't user the composestatus as some application badly
			initialise it. We use it as a key to lookup a table giving
			us the DEAD_STATUS object
		*/
		static struct {
			XComposeStatus *pt;
			struct DEAD_STATUS *to;
		}tblk[20];
		static int nbtblk=0;
		static struct DEAD_STATUS defstat = {0,0,0,1};
		static KeySym last_keysym;
		int is_shift = event->state & 1;
		struct DEAD_STATUS *deadstat = &defstat;
		#ifdef FRENCH_VERBOSE
			printf ("&deadstat = %p status = %p\n",&deadstat,status);
		#endif
		if (status != NULL){
			int i;
			for (i=0; i<nbtblk && i < 20; i++){
				if (tblk[i].pt == status){
					deadstat = tblk[i].to;
					break;
				}
			}
			if (i==nbtblk && i<20){
				struct DEAD_STATUS *d;
				#ifdef FRENCH_VERBOSE
					printf ("malloc compose_ptr\n");
					fflush (stdout);
				#endif
				d = malloc(sizeof(struct DEAD_STATUS));
				d->conf = d->grave = d->trema = 0;
				d->french_active = 1;
				tblk[nbtblk].pt = status;
				tblk[nbtblk].to = d;
				deadstat = d;
				nbtblk++;
			}
		}
		#ifdef FRENCH_VERBOSE
			printf ("kbdif avant is_shift=%d keysym=%x\n",is_shift,(int)keysym);
			fflush (stdout);
		#endif
		/*
			Patch for netscape while in a form field.
			For unknown reason, it is calling this function another
			time with the same key, but with event->serial set to 0.
			Since it is not using any XComposeStatus, we are somewhat
			lost in the compose state.
			So when we see a serial == 0, we return the last output
			of french_kbdif. A hack which seems to work
		*/
		if (event->serial == 0){
			ret = last_keysym;
		}else{
			ret = french_kbdif (event->display,keysym,is_shift,deadstat);
			last_keysym = ret;
		}
		if (ret == NoSymbol) return 0;
	}
	return ret;
}

